Bug 1161049 - llvm-3.5 breaks ghc on ARMv7
Summary: llvm-3.5 breaks ghc on ARMv7
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: ghc
Version: 21
Hardware: armv7hl
OS: Unspecified
high
high
Target Milestone: ---
Assignee: Jens Petersen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords: Reopened
Depends On:
Blocks: ARMTracker
TreeView+ depends on / blocked
 
Reported: 2014-11-06 09:44 UTC by Jens Petersen
Modified: 2015-01-14 23:55 UTC (History)
9 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2015-01-14 23:55:31 UTC


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Bugzilla 1161014 None None None Never

Internal Trackers: 1161014

Description Jens Petersen 2014-11-06 09:44:39 UTC
Description of problem:
Recently llvm was updated to 3.5 in F22 rawhide (bug 1111834).
Unfortunately currently ghc's llvm backend does not support llvm 3.5 yet.
(Even latest ghc-7.8.3 which is not yet in rawhide requires 3.1 <= llvm <= 3.4.)
In future (ghc-7.12) upstream is thinking to support officially one
known-to-work llvm version per major release.  On armv7 ghc uses
llvm as its main compiler backend (unlike other arch's).
The bottom line is that llvm-3.5 breaks ghc on arm, one of the primary
Fedora archs so we can build any Haskell packages currently in rawhide!

Version-Release number of selected component (if applicable):
3.5

How reproducible:
100%

Steps to Reproduce:
1. try to build ghc or other haskell packages in Rawhide ARM
or
2.
$ echo "main = putStrLn "hi" > hello.hs
$ ghc hello.hs
$ ./hello

Actual results:
test: schedule: re-entered unsafely.
   Perhaps a 'foreign import unsafe' should be 'safe'?

Expected results:
no runtime error (or no llvm-3.5;)

Additional info:
Workaround seems to be to add a llvm34 package to Fedora
unless there should be some simple packages available to
fix ghc llvm on ARM...  So I filed a review request in bug 1161014.

Comment 1 Jens Petersen 2014-11-06 09:46:41 UTC
s/test:/hello:/

Comment 2 Jens Petersen 2014-11-18 10:27:00 UTC
I have worked around the issue in ghc with the new llvm34 package
which is now in f22 Rawhide and seems to be working okay so far.

So probably we could close this CANTFIX say: I don't think we will see
ghc working with llvm-3.5 any time soon.

Comment 3 Jens Petersen 2014-12-25 06:04:04 UTC
(Actually let me move this to ghc, where we are actually fixing this in fedora.)

Comment 4 Fedora Update System 2014-12-25 08:30:22 UTC
ghc-7.6.3-26.3.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/ghc-7.6.3-26.3.fc21

Comment 5 Fedora Update System 2014-12-27 09:23:29 UTC
Package ghc-7.6.3-26.3.fc21:
* should fix your issue,
* was pushed to the Fedora 21 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing ghc-7.6.3-26.3.fc21'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-17631/ghc-7.6.3-26.3.fc21
then log in and leave karma (feedback).

Comment 6 Fedora Update System 2015-01-14 23:55:31 UTC
ghc-7.6.3-26.3.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.